# include "stdio.h"
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX 200
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) (yytchar= (c),(yytchar=='\n')?yylineno--:yylineno,*yysptr++=yytchar)
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng; extern char yytext[];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
/* $Id: config.pre.l,v 1.13 1994/07/25 15:40:55 gkim Exp $ */

/*
 * config.pre.l
 *
 *	lexical analyzer for preprocessing tw.config files.
 *
 *	note that escaped sequences in the <string> token must be 
 *	expanded manually.
 *
 * Gene Kim
 * Purdue University
 * October 4, 1992
 */

			/* 
			 * note that strings can contain '@'s, but they
			 * cannot start with them! 
			 *
			 * similarly, we can have #'s in strings, but they
			 * cannot be the first character! 
			 */

# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:
		{ /* eat spaces */ }
break;
case 2:
	{   
			    /* eat line continuations */ 
			    linenumber++; 
			}
break;
case 3:
	{ /* eat comments */ }
break;
case 4:
{ return INCLUDE; }
break;
case 5:
	{ return DEFINE; }
break;
case 6:
	{ return UNDEF; }
break;
case 7:
	{ return IFDEF; }
break;
case 8:
	{ return IFNDEF; }
break;
case 9:
	{ return IFHOST; }
break;
case 10:
{ return IFNHOST; }
break;
case 11:
{ return CONTENTS; }
break;
case 12:
{ return DBASEVERSION; }
break;
case 13:
	{ return ELSE; }
break;
case 14:
	{ return ENDIF; }
break;
case 15:
	{ return ECHOTHIS; }
break;
case 16:
		{ linenumber++; return EOL; }
break;
case 17:
	{ return ANDAND; }
break;
case 18:
		{ return OROR; }
break;
case 19:
	{ return LPAREN; }
break;
case 20:
	{ return RPAREN; }
break;
case 21:
	{
    char *pcin, *pcout, macro[1024], *pcm;
    static char outstring[1024];
    char *pctmp;

    yytext[yyleng] = '\0';
    yylval.string = yytext;

    SPDEBUG(20) { printf("---(prestring)---> %s\n", yytext); }

    pcin = yytext;
    pcout = outstring;
    for (; *pcin; pcin++) {
	/* check for macro expansion */
	if (*pcin == '@' && *(pcin+1) && *(pcin+1) == '@') {
	    int curlymode = 0;		/* bounded by '{' and '}' */
	    pcm = macro;
	    pcin += 2;
	    while (*pcin && (isalnum(*pcin) || *pcin == '_' ||
					*pcin == '{' || *pcin == '}')) {
		if (*pcin == '{') {
		    /* nested curlies are not allowed! */
		    if (curlymode) {
			fprintf(stderr, "warning: line %d: nested `{}' expressions are not allowed!\n", linenumber);
		    } else {
			curlymode = 1;
		    }
		    pcin++;
		    continue;
		}
		if (curlymode && *pcin == '}') {
		    pcin++;
		    curlymode = 0;
		    break;
		}

		*pcm++ = *pcin++;
	    }
	    *pcm++ = '\0';

	    SPDEBUG(20) { printf("--(macro)--> %s\n", macro); }

	    /* expand macro */
	    if (tw_mac_ifdef(macro) == 0) {
		fprintf(stderr, "warning: uninitialized directive '%s' at line %d in config file\n\t'%s' !\n\t\t(Hint: maybe a misspelled directive?)\n", macro, linenumber,
					currparsefile);
	    } else {
		/* else substitute in the input stream */
		pctmp = tw_mac_dereference(macro);
		assert(pctmp != NULL);
		SPDEBUG(20) { printf("--(dmacro)--> %s\n", pctmp); }

		strcpy(pcout, pctmp);
		pcout += strlen(pctmp);
	    }
	    pcin--;			/* rewind for loop */
	    continue;
	}
	*pcout++ = *pcin;
    }
    *pcout++ = '\0';


    yylval.string = outstring;
    if (yaccdebuglevel > 10) 
	printf("--(STRING)--> %s\n", outstring);
    return STRING;

}
break;
case -1:
break;
default:
fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */
int yyvstop[] = {
0,

21,
0,

1,
0,

16,
0,

3,
0,

21,
0,

19,
0,

20,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

17,
21,
0,

2,
0,

18,
21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

15,
21,
0,

13,
21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

15,
0,

13,
0,

21,
0,

21,
0,

21,
0,

14,
21,
0,

7,
21,
0,

21,
0,

21,
0,

21,
0,

21,
0,

6,
21,
0,

14,
0,

7,
0,

6,
0,

21,
0,

21,
0,

5,
21,
0,

9,
21,
0,

8,
21,
0,

21,
0,

21,
0,

5,
0,

9,
0,

8,
0,

21,
0,

21,
0,

10,
21,
0,

4,
21,
0,

10,
0,

4,
0,

11,
21,
0,

21,
0,

11,
0,

21,
0,

21,
0,

21,
0,

12,
21,
0,

12,
0,
0};
# define YYTYPE int
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,3,	0,0,	
3,3,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,4,	1,5,	
3,0,	3,0,	4,4,	6,6,	
14,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	6,6,	
6,0,	0,0,	0,0,	7,0,	
7,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3,0,	
1,6,	4,4,	3,13,	1,7,	
2,7,	1,8,	1,9,	3,0,	
3,0,	11,0,	11,0,	12,0,	
12,0,	6,6,	7,0,	0,0,	
10,3,	0,0,	6,6,	6,6,	
7,15,	0,0,	7,0,	7,0,	
10,3,	10,16,	0,0,	0,0,	
0,0,	13,13,	2,12,	20,20,	
11,0,	0,0,	12,0,	0,0,	
0,0,	13,0,	13,0,	0,0,	
11,0,	11,0,	12,0,	12,0,	
15,0,	15,0,	0,0,	0,0,	
17,0,	17,0,	10,3,	22,0,	
22,0,	18,3,	20,20,	10,3,	
10,3,	1,10,	0,0,	3,14,	
13,0,	18,20,	18,0,	0,0,	
19,13,	41,61,	12,18,	15,0,	
13,0,	13,0,	6,6,	17,0,	
19,13,	19,0,	22,0,	15,0,	
15,0,	21,0,	21,0,	17,0,	
17,0,	26,40,	22,0,	22,0,	
30,48,	27,41,	29,46,	18,13,	
27,42,	1,11,	2,11,	40,60,	
18,0,	18,0,	29,47,	42,62,	
43,63,	23,3,	19,13,	44,64,	
21,0,	45,65,	47,69,	19,13,	
19,13,	23,0,	23,0,	10,14,	
21,0,	21,0,	24,0,	24,0,	
48,70,	60,83,	61,84,	25,0,	
25,0,	62,85,	63,86,	64,87,	
13,19,	20,26,	20,27,	20,28,	
11,17,	46,66,	65,88,	20,29,	
23,0,	46,67,	66,89,	23,13,	
67,90,	24,0,	69,93,	46,68,	
23,0,	23,0,	25,0,	20,30,	
22,32,	24,0,	24,0,	22,33,	
18,14,	28,43,	25,0,	25,0,	
70,94,	31,0,	31,0,	18,21,	
18,22,	18,23,	28,44,	19,19,	
28,45,	18,24,	83,105,	32,0,	
32,0,	33,0,	33,0,	84,106,	
68,91,	85,107,	34,0,	34,0,	
68,92,	18,25,	88,108,	89,109,	
31,0,	90,110,	91,111,	92,112,	
35,0,	35,0,	93,113,	21,31,	
31,0,	31,0,	32,0,	94,114,	
33,0,	105,122,	36,0,	36,0,	
23,14,	34,0,	32,0,	32,0,	
33,0,	33,0,	106,123,	23,34,	
107,124,	34,0,	34,0,	35,0,	
38,0,	38,0,	110,125,	24,37,	
23,35,	37,3,	23,36,	35,0,	
35,0,	36,0,	111,126,	24,38,	
112,127,	37,0,	37,0,	113,128,	
25,39,	36,0,	36,0,	122,133,	
39,0,	39,0,	123,134,	38,0,	
127,135,	49,0,	49,0,	128,136,	
133,139,	134,140,	140,142,	38,0,	
38,0,	142,144,	144,146,	146,148,	
37,0,	50,0,	50,0,	37,13,	
51,0,	51,0,	0,0,	39,0,	
37,0,	37,0,	0,0,	32,50,	
49,0,	0,0,	31,49,	39,0,	
39,0,	0,0,	33,51,	0,0,	
49,0,	49,0,	0,0,	0,0,	
50,0,	34,52,	0,0,	51,0,	
0,0,	0,0,	52,0,	52,0,	
50,0,	50,0,	0,0,	51,0,	
51,0,	0,0,	0,0,	0,0,	
0,0,	36,54,	53,0,	53,0,	
0,0,	0,0,	35,53,	0,0,	
54,0,	54,0,	0,0,	0,0,	
0,0,	52,0,	38,58,	0,0,	
0,0,	0,0,	55,0,	55,0,	
37,14,	52,0,	52,0,	56,0,	
56,0,	53,0,	0,0,	0,0,	
37,55,	0,0,	0,0,	54,0,	
37,56,	53,0,	53,0,	39,59,	
0,0,	0,0,	37,57,	54,0,	
54,0,	55,0,	57,0,	57,0,	
0,0,	0,0,	56,0,	58,0,	
58,0,	55,0,	55,0,	0,0,	
59,0,	59,0,	56,0,	56,0,	
49,71,	71,0,	71,0,	0,0,	
51,73,	0,0,	0,0,	0,0,	
0,0,	57,0,	0,0,	50,72,	
72,0,	72,0,	58,0,	0,0,	
0,0,	57,0,	57,0,	59,0,	
0,0,	0,0,	58,0,	58,0,	
71,0,	0,0,	0,0,	59,0,	
59,0,	73,0,	73,0,	0,0,	
71,0,	71,0,	0,0,	72,0,	
52,74,	0,0,	53,75,	74,0,	
74,0,	75,0,	75,0,	72,0,	
72,0,	0,0,	0,0,	0,0,	
54,76,	0,0,	0,0,	0,0,	
73,0,	0,0,	55,77,	76,0,	
76,0,	0,0,	0,0,	0,0,	
73,0,	73,0,	74,0,	0,0,	
75,0,	0,0,	77,0,	77,0,	
0,0,	56,78,	74,0,	74,0,	
75,0,	75,0,	0,0,	0,0,	
0,0,	57,79,	76,0,	78,0,	
78,0,	57,80,	79,0,	79,0,	
80,0,	80,0,	76,0,	76,0,	
59,82,	77,0,	58,81,	0,0,	
0,0,	71,95,	81,0,	81,0,	
0,0,	77,0,	77,0,	0,0,	
82,0,	82,0,	78,0,	0,0,	
72,96,	79,0,	0,0,	80,0,	
0,0,	0,0,	78,0,	78,0,	
0,0,	79,0,	79,0,	80,0,	
80,0,	81,0,	95,0,	95,0,	
96,0,	96,0,	0,0,	82,0,	
0,0,	81,0,	81,0,	0,0,	
0,0,	0,0,	73,97,	82,0,	
82,0,	97,0,	97,0,	98,0,	
98,0,	99,0,	99,0,	100,0,	
100,0,	95,0,	0,0,	96,0,	
0,0,	0,0,	0,0,	0,0,	
76,98,	95,0,	95,0,	96,0,	
96,0,	0,0,	0,0,	0,0,	
97,0,	0,0,	98,0,	77,99,	
99,0,	0,0,	100,0,	0,0,	
97,0,	97,0,	98,0,	98,0,	
99,0,	99,0,	100,0,	100,0,	
101,0,	101,0,	79,101,	102,0,	
102,0,	103,0,	103,0,	0,0,	
0,0,	0,0,	104,0,	104,0,	
0,0,	78,100,	80,102,	0,0,	
0,0,	115,0,	115,0,	0,0,	
0,0,	82,104,	0,0,	101,0,	
0,0,	0,0,	102,0,	0,0,	
103,0,	0,0,	81,103,	101,0,	
101,0,	104,0,	102,0,	102,0,	
103,0,	103,0,	116,0,	116,0,	
115,0,	104,0,	104,0,	0,0,	
117,0,	117,0,	0,0,	95,115,	
115,0,	115,0,	118,0,	118,0,	
0,0,	97,117,	119,0,	119,0,	
0,0,	96,116,	0,0,	0,0,	
0,0,	116,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	117,0,	
0,0,	116,0,	116,0,	120,0,	
120,0,	118,0,	100,118,	117,0,	
117,0,	119,0,	0,0,	0,0,	
0,0,	118,0,	118,0,	121,0,	
121,0,	119,0,	119,0,	129,0,	
129,0,	130,0,	130,0,	0,0,	
0,0,	101,119,	120,0,	0,0,	
103,121,	0,0,	0,0,	0,0,	
131,0,	131,0,	120,0,	120,0,	
132,0,	132,0,	121,0,	0,0,	
0,0,	102,120,	129,0,	0,0,	
130,0,	0,0,	121,0,	121,0,	
137,0,	137,0,	129,0,	129,0,	
130,0,	130,0,	0,0,	131,0,	
115,129,	0,0,	0,0,	132,0,	
138,0,	138,0,	116,130,	131,0,	
131,0,	141,0,	141,0,	132,0,	
132,0,	0,0,	0,0,	137,0,	
143,0,	143,0,	0,0,	0,0,	
0,0,	145,0,	145,0,	137,0,	
137,0,	0,0,	0,0,	138,0,	
0,0,	0,0,	0,0,	0,0,	
141,0,	147,0,	147,0,	138,0,	
138,0,	0,0,	0,0,	143,0,	
141,0,	141,0,	0,0,	0,0,	
145,0,	0,0,	0,0,	143,0,	
143,0,	0,0,	0,0,	121,132,	
145,0,	145,0,	120,131,	0,0,	
147,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
147,0,	147,0,	0,0,	0,0,	
0,0,	129,137,	130,138,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	141,143,	0,0,	0,0,	
0,0,	0,0,	138,141,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	143,145,	0,0,	
0,0,	0,0,	145,147,	0,0,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		0,	
yycrank+-2,	yysvec+1,	0,	
yycrank+-3,	0,		yyvstop+1,
yycrank+5,	0,		yyvstop+3,
yycrank+0,	0,		yyvstop+5,
yycrank+-14,	0,		yyvstop+7,
yycrank+-18,	yysvec+3,	yyvstop+9,
yycrank+0,	0,		yyvstop+11,
yycrank+0,	0,		yyvstop+13,
yycrank+-51,	0,		yyvstop+15,
yycrank+-36,	yysvec+3,	yyvstop+17,
yycrank+-38,	yysvec+3,	yyvstop+19,
yycrank+-64,	yysvec+3,	yyvstop+21,
yycrank+-6,	yysvec+10,	yyvstop+23,
yycrank+-71,	yysvec+3,	yyvstop+25,
yycrank+0,	0,		yyvstop+28,
yycrank+-75,	yysvec+3,	yyvstop+30,
yycrank+-88,	0,		yyvstop+33,
yycrank+-99,	0,		yyvstop+35,
yycrank+58,	0,		0,	
yycrank+-104,	yysvec+3,	yyvstop+37,
yycrank+-78,	yysvec+3,	yyvstop+39,
yycrank+-132,	0,		yyvstop+41,
yycrank+-137,	yysvec+3,	yyvstop+43,
yycrank+-142,	yysvec+3,	yyvstop+45,
yycrank+6,	0,		0,	
yycrank+23,	0,		0,	
yycrank+82,	0,		0,	
yycrank+20,	0,		0,	
yycrank+10,	0,		0,	
yycrank+-176,	yysvec+3,	yyvstop+47,
yycrank+-186,	yysvec+3,	yyvstop+49,
yycrank+-188,	yysvec+3,	yyvstop+51,
yycrank+-193,	yysvec+3,	yyvstop+53,
yycrank+-203,	yysvec+3,	yyvstop+55,
yycrank+-213,	yysvec+3,	yyvstop+57,
yycrank+-240,	0,		yyvstop+59,
yycrank+-227,	yysvec+3,	yyvstop+61,
yycrank+-247,	yysvec+3,	yyvstop+63,
yycrank+17,	0,		0,	
yycrank+4,	0,		0,	
yycrank+29,	0,		0,	
yycrank+28,	0,		0,	
yycrank+20,	0,		0,	
yycrank+37,	0,		0,	
yycrank+61,	0,		0,	
yycrank+39,	0,		0,	
yycrank+48,	0,		0,	
yycrank+-252,	yysvec+3,	yyvstop+65,
yycrank+-264,	yysvec+3,	yyvstop+67,
yycrank+-267,	yysvec+3,	yyvstop+69,
yycrank+-293,	yysvec+3,	yyvstop+71,
yycrank+-305,	yysvec+3,	yyvstop+73,
yycrank+-311,	yysvec+3,	yyvstop+75,
yycrank+-321,	yysvec+3,	yyvstop+77,
yycrank+-326,	yysvec+3,	yyvstop+79,
yycrank+-345,	yysvec+3,	yyvstop+81,
yycrank+-350,	yysvec+3,	yyvstop+83,
yycrank+-355,	yysvec+3,	yyvstop+85,
yycrank+33,	0,		0,	
yycrank+35,	0,		0,	
yycrank+48,	0,		0,	
yycrank+43,	0,		0,	
yycrank+54,	0,		0,	
yycrank+57,	0,		0,	
yycrank+65,	0,		0,	
yycrank+57,	0,		0,	
yycrank+100,	0,		0,	
yycrank+62,	0,		0,	
yycrank+83,	0,		0,	
yycrank+-360,	yysvec+3,	yyvstop+87,
yycrank+-371,	yysvec+3,	yyvstop+89,
yycrank+-388,	yysvec+3,	yyvstop+91,
yycrank+-398,	yysvec+3,	yyvstop+93,
yycrank+-400,	yysvec+3,	yyvstop+96,
yycrank+-414,	yysvec+3,	yyvstop+99,
yycrank+-425,	yysvec+3,	yyvstop+101,
yycrank+-438,	yysvec+3,	yyvstop+103,
yycrank+-441,	yysvec+3,	yyvstop+105,
yycrank+-443,	yysvec+3,	yyvstop+107,
yycrank+-453,	yysvec+3,	yyvstop+109,
yycrank+-459,	yysvec+3,	yyvstop+111,
yycrank+93,	0,		0,	
yycrank+98,	0,		0,	
yycrank+91,	0,		0,	
yycrank+0,	0,		yyvstop+113,
yycrank+0,	0,		yyvstop+115,
yycrank+104,	0,		0,	
yycrank+105,	0,		0,	
yycrank+94,	0,		0,	
yycrank+109,	0,		0,	
yycrank+100,	0,		0,	
yycrank+97,	0,		0,	
yycrank+117,	0,		0,	
yycrank+-477,	yysvec+3,	yyvstop+117,
yycrank+-479,	yysvec+3,	yyvstop+119,
yycrank+-492,	yysvec+3,	yyvstop+121,
yycrank+-494,	yysvec+3,	yyvstop+123,
yycrank+-496,	yysvec+3,	yyvstop+126,
yycrank+-498,	yysvec+3,	yyvstop+129,
yycrank+-531,	yysvec+3,	yyvstop+131,
yycrank+-534,	yysvec+3,	yyvstop+133,
yycrank+-536,	yysvec+3,	yyvstop+135,
yycrank+-541,	yysvec+3,	yyvstop+137,
yycrank+111,	0,		0,	
yycrank+112,	0,		0,	
yycrank+131,	0,		0,	
yycrank+0,	0,		yyvstop+140,
yycrank+0,	0,		yyvstop+142,
yycrank+122,	0,		0,	
yycrank+144,	0,		0,	
yycrank+133,	0,		0,	
yycrank+151,	0,		0,	
yycrank+0,	0,		yyvstop+144,
yycrank+-548,	yysvec+3,	yyvstop+146,
yycrank+-569,	yysvec+3,	yyvstop+148,
yycrank+-575,	yysvec+3,	yyvstop+150,
yycrank+-581,	yysvec+3,	yyvstop+153,
yycrank+-585,	yysvec+3,	yyvstop+156,
yycrank+-602,	yysvec+3,	yyvstop+159,
yycrank+-614,	yysvec+3,	yyvstop+161,
yycrank+139,	0,		0,	
yycrank+157,	0,		0,	
yycrank+0,	0,		yyvstop+163,
yycrank+0,	0,		yyvstop+165,
yycrank+0,	0,		yyvstop+167,
yycrank+144,	0,		0,	
yycrank+162,	0,		0,	
yycrank+-618,	yysvec+3,	yyvstop+169,
yycrank+-620,	yysvec+3,	yyvstop+171,
yycrank+-631,	yysvec+3,	yyvstop+173,
yycrank+-635,	yysvec+3,	yyvstop+176,
yycrank+149,	0,		0,	
yycrank+151,	0,		0,	
yycrank+0,	0,		yyvstop+179,
yycrank+0,	0,		yyvstop+181,
yycrank+-647,	yysvec+3,	yyvstop+183,
yycrank+-659,	yysvec+3,	yyvstop+186,
yycrank+0,	0,		yyvstop+188,
yycrank+151,	0,		0,	
yycrank+-664,	yysvec+3,	yyvstop+190,
yycrank+164,	0,		0,	
yycrank+-671,	yysvec+3,	yyvstop+192,
yycrank+159,	0,		0,	
yycrank+-676,	yysvec+3,	yyvstop+194,
yycrank+161,	0,		0,	
yycrank+-688,	yysvec+3,	yyvstop+196,
yycrank+0,	0,		yyvstop+199,
0,	0,	0};
struct yywork *yytop = yycrank+786;
struct yysvf *yybgin = yysvec+1;
char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
011 ,01  ,01  ,'#' ,01  ,01  ,01  ,01  ,
'(' ,')' ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,0134,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
0};
char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
#ident	"@(#)libl:lib/ncform	1.3"
#if defined(__cplusplus)
#   include <stdlib.h>
#   if defined(__cplusplus) && defined (STDIO)
	extern "C" void allprint(const char);
	extern "C" void sprint (const char *);
#   else
	void allprint(const char);
	void sprint (const char *);
#   endif
#endif

int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
char yytext[YYLMAX];
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
#if defined(__cplusplus)
#   if defined(__cplusplus) && defined (STDIO)
	extern "C"
#   endif
int yylook(void)
#else
yylook()
#endif
	{
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
#   if defined(__cplusplus) && ! defined (STDIO)
			if(debug)*yyout << "state " << yystate-yysvec-1 << endl;
#   else
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
#   endif
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
			*yylastch++ = yych = input();
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
#   if defined(__cplusplus) && ! defined (STDIO)
				*yyout << "char ";
				allprint (yych);
				*yyout << endl;
#   else
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
#   endif
				}
# endif
			yyr = yyt;
			if ( (void *)yyt > (void *)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((void *)yyt < (void *)yycrank) {	/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
#   if defined(__cplusplus) && ! defined (STDIO)
				if(debug)*yyout << "compressed state\n";
#   else
				if(debug)fprintf(yyout,"compressed state\n");
#   endif
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
#   if defined(__cplusplus) && ! defined (STDIO)
					*yyout << "try fall back character ";
					allprint (YYU(yymatch[yych]));
					*yyout << endl;
#   else
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
#   endif
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
#   if defined(__cplusplus) && ! defined (STDIO)
				if(debug)*yyout << "fall back to state "
					<< yystate-yysvec-1 << endl;
#   else
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
#   endif
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
#   if defined(__cplusplus) && ! defined (STDIO)
				*yyout << "state " << yystate-yysvec-1
					<< " char ";
				allprint (yych);
				*yyout << endl;
#   else
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
#   endif
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
#   if defined(__cplusplus) && ! defined (STDIO)
			*yyout << "stopped at " << *(lsp-1)-yysvec-1
			       << " with ";
			allprint (yych);
			*yyout << endl;
#   else
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
#   endif
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
#   if defined(__cplusplus) && ! defined (STDIO)
					*yyout << "\nmatch ";
					sprint (yytext);
					*yyout << " action " << *yyfnd << endl;
#   else
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
#   endif
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
		yylastch=yytext;
# ifdef LEXDEBUG
#   if defined(__cplusplus) && ! defined (STDIO)
		if(debug)*yyout << endl;
#   else
		if(debug)putchar('\n');
#   endif
# endif
		}
	}
#if defined(__cplusplus)
int yyback(int *p, int m)
#else
yyback(p, m)
	int *p;
#endif
{
if (p==0) return(0);
while (*p)
	{
	if (*p++ == m)
		return(1);
	}
return(0);
}
	/* the following are only used in the lex library */
#if defined(__cplusplus)
int yyinput(void)
#else
yyinput()
#endif
	{
	return(input());
	}
#if defined(__cplusplus)
void yyoutput(int c)
#else
yyoutput(c)
  int c;
#endif
	{
	output(c);
	}
#if defined(__cplusplus)
void yyunput(int c)
#else
yyunput(c)
   int c;
#endif
       {
	unput(c);
	}

/*
 * For the HCR/C++ compiler, the main() function is used in the libC.a 
 * library but defined in the libl.a library.  However, since libl.a
 * is placed before libC.a in the cc command line within the C++ compiler
 * driver, the linker cannot find main().  To get around this, we define
 * a dummy function here which calls it.
*/
#if defined(__cplusplus)
extern "C" int main(void);
void _lldumMain_() { main(); }
#endif
