
/*  A Bison parser, made from config.pre.y  */

#define	COMMENT	258
#define	EOL	259
#define	STRING	260
#define	INCLUDE	261
#define	DEFINE	262
#define	UNDEF	263
#define	ELSE	264
#define	ENDIF	265
#define	CONTENTS	266
#define	DBASEVERSION	267
#define	LPAREN	268
#define	RPAREN	269
#define	ANDAND	270
#define	OROR	271
#define	ECHOTHIS	272
#define	BSLASH	273
#define	ESCCHAR	274
#define	IFDEF	275
#define	IFNDEF	276
#define	IFHOST	277
#define	IFNHOST	278

#line 19 "config.pre.y"

/* $Id: config.pre.y,v 1.23 1994/08/04 03:44:32 gkim Exp $ */

/*
 * config.y
 *
 *	tw.config preprocessor parser for yacc.
 *
 *	This implementation does an unfortunately large number of 
 *	malloc()'s and free()'s to store the lexeme values.  Although
 *	memory leaks are few, too much time is spent doing memory
 *	allocation.
 *
 *	At this point, I would argue that this is not too significant,
 *	since we only run this routine once.
 *
 * Gene Kim
 * Purdue University
 * October 5, 1992
 *
 * Modified by Cal Page to work with linux, March 9, 1994
 */

#include "../include/config.h"
#include <stdio.h>
#ifdef STDLIBH
#include <stdlib.h>
#endif
#ifdef STRINGH
#include <string.h>
#else
#include <strings.h>
#endif
#ifdef MALLOCH
#include <malloc.h>
#endif
#include <assert.h>
#include <sys/param.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "../include/list.h"
#include "../include/tripwire.h"

extern FILE *yyin;
extern FILE *yyout;

#ifdef TW_LINUX
#include <malloc.h>

	void *yy_flex_realloc(void *x,int y) { return realloc(x,y); }
	void *yy_flex_alloc  (int y        ) { return malloc(y);    }
        void yy_flex_free    (void *x      ) { free(x); }

#define yy_strcpy(a,b) strcpy((a),(b))

#endif /* TW_LINUX */

#define INCLUDE_STACK_SZ 	16	/* max num of nested includes */

int yaccdebuglevel = 0;

static int linenumber = 1;

static FILE *fp_stack[INCLUDE_STACK_SZ];
static int linenumber_stack[INCLUDE_STACK_SZ];
static char *filename_stack[INCLUDE_STACK_SZ];
static int stackpointer = 0;
static int found_db_version = 0;
static struct list **pp_entry_list_global = NULL;

static char currparsefile[MAXPATHLEN+1024];

/* prototypes */
static char *string_dequote();
static void include_push();
static FILE *include_pop();

/* this is for some versions of flex and bison, who don't make any
 * effort to look like lex and yacc.
 */

#ifdef LINUX
extern FILE **yyin, *yyout;
void *yy_flex_realloc(void *x,int y) { return realloc(x,y); }
void *yy_flex_alloc  (int y        ) { return malloc(y); }
void  yy_flex_free   (void *x      ) { free(x); }
#endif

struct comp {
    char *string;
    int directive;
};


#line 115 "config.pre.y"
typedef union {
    struct comp *comp;
    char 	*string;
    long 	val;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __STDC__
#define const
#endif



#define	YYFINAL		74
#define	YYFLAG		-32768
#define	YYNTBASE	24

#define YYTRANSLATE(x) ((unsigned)(x) <= 278 ? yytranslate[x] : 38)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23
};

static const short yyprhs[] = {     0,
     0,     3,     4,     7,    10,    13,    14,    17,    20,    23,
    24,    28,    32,    36,    38,    42,    46,    50,    52,    55,
    59,    62,    63,    71,    72,    80,    81,    89,    90,    98,
   101,   104,   107,   110,   113,   114
};

static const short yyrhs[] = {    24,
    25,     0,     0,    31,     4,     0,    36,     4,     0,    26,
    27,     0,     0,    31,     4,     0,    36,     4,     0,     9,
    26,     0,     0,    13,    29,    14,     0,    29,    15,    29,
     0,    29,    16,    29,     0,    37,     0,    13,    30,    14,
     0,    30,    15,    30,     0,    30,    16,    30,     0,    37,
     0,     7,    37,     0,     7,    37,    37,     0,     8,    37,
     0,     0,    20,    29,    32,     4,    26,    28,    10,     0,
     0,    21,    29,    33,     4,    26,    28,    10,     0,     0,
    22,    30,    34,     4,    26,    28,    10,     0,     0,    23,
    30,    35,     4,    26,    28,    10,     0,     6,    37,     0,
    11,    37,     0,    17,    36,     0,    12,    37,     0,    36,
    37,     0,     0,     5,     0
};

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   134,   135,   140,   151,   165,   193,   199,   200,   203,   207,
   213,   217,   221,   225,   231,   235,   239,   243,   248,   255,
   261,   264,   268,   277,   281,   290,   294,   303,   307,   316,
   323,   339,   344,   371,   401,   407
};

static const char * const yytname[] = {   "$",
"error","$illegal.","COMMENT","EOL","STRING","INCLUDE","DEFINE","UNDEF","ELSE","ENDIF",
"CONTENTS","DBASEVERSION","LPAREN","RPAREN","ANDAND","OROR","ECHOTHIS","BSLASH","ESCCHAR","IFDEF",
"IFNDEF","IFHOST","IFNHOST","lines","line","colines","coline","else","if_expr","host_expr",
"directive","@1","@2","@3","@4","words","word",""
};
#endif

static const short yyr1[] = {     0,
    24,    24,    25,    25,    26,    26,    27,    27,    28,    28,
    29,    29,    29,    29,    30,    30,    30,    30,    31,    31,
    31,    32,    31,    33,    31,    34,    31,    35,    31,    31,
    31,    31,    31,    36,    36,    37
};

static const short yyr2[] = {     0,
     2,     0,     2,     2,     2,     0,     2,     2,     2,     0,
     3,     3,     3,     1,     3,     3,     3,     1,     2,     3,
     2,     0,     7,     0,     7,     0,     7,     0,     7,     2,
     2,     2,     2,     2,     0,     1
};

static const short yydefact[] = {     2,
    35,     0,     0,     0,     0,     0,    35,     0,     0,     0,
     0,     1,     0,     0,    36,    30,    19,    21,    31,    33,
    32,     0,    22,    14,    24,     0,    26,    18,    28,     3,
     4,    34,    20,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    11,    12,    13,     6,     6,    15,    16,
    17,     6,     6,    35,    35,    35,    35,     6,     5,     0,
     0,     0,     0,     0,     0,    35,    23,     7,     8,    25,
    27,    29,     0,     0
};

static const short yydefgoto[] = {     1,
    12,    54,    59,    60,    23,    27,    61,    37,    38,    42,
    43,    62,    24
};

static const short yypact[] = {-32768,
    41,     9,     9,     9,     9,     9,-32768,    13,    13,    20,
    20,-32768,     2,    27,-32768,-32768,     9,-32768,-32768,-32768,
     9,    13,    30,-32768,    30,    20,    35,-32768,    35,-32768,
-32768,-32768,-32768,    14,    13,    13,     7,    12,    28,    20,
    20,    36,    53,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,    59,    59,    59,    59,-32768,-32768,    49,
    70,    68,    65,    67,    76,    77,-32768,-32768,-32768,-32768,
-32768,-32768,    78,-32768
};

static const short yypgoto[] = {-32768,
-32768,   -31,-32768,    -1,     1,    -6,    89,-32768,-32768,-32768,
-32768,     6,    -2
};


#define	YYLAST		100


static const short yytable[] = {    16,
    17,    18,    19,    20,    29,    30,    14,    28,    28,    25,
    47,    32,    21,    15,    33,    48,    55,    15,    32,    39,
    56,    57,    34,    28,    15,    22,    66,    44,    35,    36,
    31,    15,    26,    50,    51,    45,    46,    28,    28,    52,
    73,    49,    40,    41,    35,    36,     2,     3,     4,    40,
    41,     5,     6,    63,    64,    65,    53,     7,    67,    32,
     8,     9,    10,    11,     2,     3,     4,    58,   -10,     5,
     6,    69,    15,    68,    70,     7,    71,    74,     8,     9,
    10,    11,     2,     3,     4,    72,    -9,     5,     6,    13,
     0,     0,     0,     7,     0,     0,     8,     9,    10,    11
};

static const short yycheck[] = {     2,
     3,     4,     5,     6,    11,     4,     1,    10,    11,     9,
     4,    14,     7,     5,    17,     4,    48,     5,    21,    26,
    52,    53,    22,    26,     5,    13,    58,    14,    15,    16,
     4,     5,    13,    40,    41,    35,    36,    40,    41,     4,
     0,    14,    15,    16,    15,    16,     6,     7,     8,    15,
    16,    11,    12,    55,    56,    57,     4,    17,    10,    62,
    20,    21,    22,    23,     6,     7,     8,     9,    10,    11,
    12,     4,     5,     4,    10,    17,    10,     0,    20,    21,
    22,    23,     6,     7,     8,    10,    10,    11,    12,     1,
    -1,    -1,    -1,    17,    -1,    -1,    20,    21,    22,    23
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* Not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__)
#include <alloca.h>
#else /* Not sparc */
#ifdef MSDOS
#include <malloc.h>
#endif /* MSDOS */
#endif /* Not sparc.  */
#endif /* Not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif

#line 160 "/usr/local/lib/bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/

#define YYPOPSTACK   (yyvsp--, yysp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yysp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
#ifdef YYLSP_NEEDED
		 &yyls1, size * sizeof (*yylsp),
#endif
		 &yystacksize);

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Next token is %d (%s)\n", yychar, yytname[yychar1]);
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symboles being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 3:
#line 141 "config.pre.y"
{
		/*
		linenumber++;
		*/

		if (yyvsp[-1].string)	{ 
		    fprintf(yyout, "%s\n", yyvsp[-1].string); 
		    free(yyvsp[-1].string);
		}
	    ;
    break;}
case 4:
#line 152 "config.pre.y"
{
		/*
		linenumber++; 
		*/

		if (yyvsp[-1].string)	{ 
		    fprintf(yyout, "%s\n", yyvsp[-1].string); 
		    free(yyvsp[-1].string);
		}
	    ;
    break;}
case 5:
#line 166 "config.pre.y"
{
	    	/* If coline is null, just pass on colines. */
	    	if (yyvsp[0].string == NULL) {
		    yyval.string = yyvsp[-1].string;
		} else {
		    /* concatenate the two terminals together */
		    if (yyvsp[-1].string == NULL) {
			yyval.string = (char *) malloc((unsigned) strlen(yyvsp[0].string) + 1);
			yyval.string[0] = '\0';
		    }
		    else {
			yyval.string = (char *) malloc((unsigned) 
					    (strlen(yyvsp[-1].string) + strlen(yyvsp[0].string)) + 2);
			(void) strcpy(yyval.string, yyvsp[-1].string);
			(void) strcat(yyval.string, "\n");
    
			/* free up the left component */
			free(yyvsp[-1].string);
		    }
		    (void) strcat(yyval.string, yyvsp[0].string);
    
		    /* free up the right component */
		    if (yyvsp[0].string)
			free(yyvsp[0].string);
		}
		SPDEBUG(11) printf("--(coline)--> (%s)\n", yyval.string);
	    ;
    break;}
case 6:
#line 194 "config.pre.y"
{
		yyval.string = NULL;
	    ;
    break;}
case 7:
#line 199 "config.pre.y"
{ yyval.string = yyvsp[-1].string; /* linenumber++; */;
    break;}
case 8:
#line 200 "config.pre.y"
{ yyval.string = yyvsp[-1].string; /* linenumber++; */;
    break;}
case 9:
#line 204 "config.pre.y"
{
		yyval.string = yyvsp[0].string;
	    ;
    break;}
case 10:
#line 208 "config.pre.y"
{
		yyval.string = NULL;
	    ;
    break;}
case 11:
#line 214 "config.pre.y"
{ 
		yyval.val = yyvsp[-1].val;
	    ;
    break;}
case 12:
#line 218 "config.pre.y"
{
		yyval.val = yyvsp[-2].val && yyvsp[0].val;
	    ;
    break;}
case 13:
#line 222 "config.pre.y"
{
		yyval.val = yyvsp[-2].val || yyvsp[0].val;
	    ;
    break;}
case 14:
#line 226 "config.pre.y"
{
		check_varname(yyvsp[0].comp->string);
		yyval.val = tw_mac_ifdef(yyvsp[0].comp->string);
	    ;
    break;}
case 15:
#line 232 "config.pre.y"
{ 
		yyval.val = yyvsp[-1].val;
	    ;
    break;}
case 16:
#line 236 "config.pre.y"
{
		yyval.val = yyvsp[-2].val && yyvsp[0].val;
	    ;
    break;}
case 17:
#line 240 "config.pre.y"
{
		yyval.val = yyvsp[-2].val || yyvsp[0].val;
	    ;
    break;}
case 18:
#line 244 "config.pre.y"
{
		yyval.val = tw_mac_ifhost(yyvsp[0].comp->string);
	    ;
    break;}
case 19:
#line 250 "config.pre.y"
{	
		check_varname(yyvsp[0].comp->string);
	   	tw_mac_define(yyvsp[0].comp->string, ""); 
	        yyval.string = NULL; 
	    ;
    break;}
case 20:
#line 256 "config.pre.y"
{ 
		check_varname(yyvsp[-1].comp->string);
		tw_mac_define(yyvsp[-1].comp->string, yyvsp[0].comp->string); yyval.string = NULL; 
	    ;
    break;}
case 21:
#line 261 "config.pre.y"
{ 
		check_varname(yyvsp[0].comp->string);
		tw_mac_undef(yyvsp[0].comp->string); yyval.string = NULL; ;
    break;}
case 22:
#line 265 "config.pre.y"
{
		yyvsp[-1].val = yyvsp[0].val;
	    ;
    break;}
case 23:
#line 269 "config.pre.y"
{
		if (yyvsp[-6].val) { yyval.string = yyvsp[-2].string; }
		else 	{ yyval.string = yyvsp[-1].string; }

		/*
		linenumber++;
		*/
	    ;
    break;}
case 24:
#line 278 "config.pre.y"
{
		yyvsp[-1].val = !yyvsp[0].val;
	    ;
    break;}
case 25:
#line 282 "config.pre.y"
{
		if (yyvsp[-6].val) { yyval.string = yyvsp[-2].string; }
		else 	{ yyval.string = yyvsp[-1].string; }

		/*
		linenumber++;
		*/
	    ;
    break;}
case 26:
#line 291 "config.pre.y"
{
		yyvsp[-1].val = yyvsp[0].val;
	    ;
    break;}
case 27:
#line 295 "config.pre.y"
{
		if (yyvsp[-6].val) { yyval.string = yyvsp[-2].string; }
		else 	{ yyval.string = yyvsp[-1].string; }

		/*
		linenumber++;
		*/
	    ;
    break;}
case 28:
#line 304 "config.pre.y"
{
		yyvsp[-1].val = !yyvsp[0].val;
	    ;
    break;}
case 29:
#line 308 "config.pre.y"
{
		if (yyvsp[-6].val) { yyval.string = yyvsp[-2].string; }
		else 	{ yyval.string = yyvsp[-1].string; }

		/*
		linenumber++;
		*/
	    ;
    break;}
case 30:
#line 317 "config.pre.y"
{
		/* push a new @@include file onto the include stack */
		include_push(yyvsp[0].comp->string, &yyin);
		yyval.string = NULL;

	    ;
    break;}
case 31:
#line 324 "config.pre.y"
{
		char *pc = "@@contents ";

		/* record contents in list */
		list_set(yyvsp[0].comp->string, "", 0, pp_entry_list_global);

		/* reconstruct and emit the entire string */
		yyval.string = (char *) malloc((unsigned) (strlen(yyvsp[0].comp->string) + strlen(pc)) + 1);
		(void) strcpy(yyval.string, pc);
		(void) strcat(yyval.string, yyvsp[0].comp->string);

		/* free up the right side */
		free(yyvsp[0].comp->string);
		free(yyvsp[0].comp);
	    ;
    break;}
case 32:
#line 340 "config.pre.y"
{
		fprintf(stderr, "tw.config: echo: %s\n", yyvsp[0].string);
		yyval.string = NULL;
	    ;
    break;}
case 33:
#line 345 "config.pre.y"
{
		int version;

		if (sscanf(yyvsp[0].comp->string, "%d", &version) != 1) {
		    yyerror("");
		}

		/* check if the database format is too old */
		if (version != db_version_num) {
		    fprintf(stderr, 
"error: database format %d is no longer supported!\n\tSee tw.config(5) manual page for details)\n\t'%s' (expecting version %d)!\n",
			version, currparsefile, db_version_num);
		    exit(1);
		}

		/* free up the right side */
		free(yyvsp[0].comp->string);
		free(yyvsp[0].comp);

		/* we must see one of these productions in the file */
		found_db_version = 1;

		yyval.string = NULL;
	    ;
    break;}
case 34:
#line 372 "config.pre.y"
{
		/* concatenate the two terminals together */
		if (yyvsp[-1].string == NULL) {
		    yyval.string = (char *) malloc((unsigned) strlen(yyvsp[0].comp->string) + 1);
		    yyval.string[0] = '\0';
		}
		else {
		    yyval.string = (char *) malloc((unsigned) 
				(strlen(yyvsp[-1].string) + strlen(yyvsp[0].comp->string)) + 2);
		    (void) strcpy(yyval.string, yyvsp[-1].string);
		    /* XXX: This doesn't work!
		    if ($2 && (!$2->directive))
		    */
		    if (yyvsp[0].comp)
			(void) strcat(yyval.string, " ");

		    /* free up the left component */
		    free(yyvsp[-1].string);
		}
		(void) strcat(yyval.string, yyvsp[0].comp->string);

		/* free up the right component */
		if (yyvsp[0].comp) { 
		    free(yyvsp[0].comp->string);
		    free(yyvsp[0].comp);
		}

		SPDEBUG(11) printf("--(words)--> (%s)\n", yyval.string);
	    ;
    break;}
case 35:
#line 402 "config.pre.y"
{
		yyval.string = NULL;
	    ;
    break;}
case 36:
#line 408 "config.pre.y"
{
	    	struct comp *pcomp;
		char *pc;

		yyval.comp = (struct comp *) malloc(sizeof(struct comp));

		pc = yyvsp[0].string;
		yyval.comp->string = strcpy((char *) malloc((unsigned) strlen(yyvsp[0].string) + 1), yyvsp[0].string);
		yyval.comp->directive = 0;
	    ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 423 "/usr/local/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  for (x = 0; x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) xmalloc(size + 15);
	  strcpy(msg, "parse error");

	  if (count < 5)
	    {
	      count = 0;
	      for (x = 0; x < (sizeof(yytname) / sizeof(char *)); x++)
		if (yycheck[x + yyn] == x)
		  {
		    strcat(msg, count == 0 ? ", expecting `" : " or `");
		    strcat(msg, yytname[x]);
		    strcat(msg, "'");
		    count++;
		  }
	    }
	  yyerror(msg);
	  free(msg);
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 421 "config.pre.y"


#include "config.lex.c"

/*ARGSUSED*/
yyerror(s)
    char *s;
{
     fprintf(stderr, 
	"error: syntax error at line %d in config file\n\t'%s' !\n", 
		++linenumber, currparsefile);
}

/*
 * void
 * tw_macro_parse(char *filename, FILE *fpin, FILE *fpout, 
 *						struct list **pp_entry_list)
 *
 *	wrapper around yyparse(), initiailzing input and output data.
 */

void
tw_macro_parse(filename, fpin, fpout, pp_entry_list)
    char *filename;
    FILE *fpin, *fpout;
    struct list **pp_entry_list;
{
    static int firsttime = 1;
    stackpointer = 0;

    /* set up input and output pointers */
    yyin = fpin;
    yyout = fpout;

#ifdef FLEX_SCANNER
    if (!firsttime) { 
	yyrestart(yyin);
    } else {
	firsttime = 0;
    }
#endif

    /* set up initial filename */
    strcpy( currparsefile, filename );

    pp_entry_list_global = pp_entry_list;

    (void) yyparse();
}

/* counters odd behaviour of flex -- Simon Leinen */
#ifdef yywrap
# undef yywrap
#endif

yywrap()
{
    /* check to see if we've reached the bottom of the @@include stack */
    if (include_pop()) {
	linenumber++;
	return 0;
    }

    /* close up parser */
    return 1;
}

/*
 * static char *
 * string_dequote(char *s)
 *
 *	remove pairs of quoted strings.
 */

static char *
string_dequote(s)
    char *s;
{
    char temp[1024];
	int n = strlen(s) - 2; /* length to copy less quotes */

    /* do we need to do anything? */
    if (s[0] != '"') 		{ return s; }

    (void) strncpy(temp, s+1, n);
	/* terminate the string */
	temp[n] = '\0';
    (void) strcpy(s, temp);

    return s;

}

/* 
 * void
 * include_push(char *filename, FILE **p_fp_old)
 *
 *	return a stdio (FILE *) pointer to the opened (filename), saving 
 *	the old (FILE *) pointer and line number on the stack.
 *
 *	returns (NULL) when we pop back to the original file.
 */

static void
include_push(filename, p_fp_old)
    char *filename;
    FILE **p_fp_old;
{
    static FILE *fp;
    char *pc;
    extern int  errno;

    /* check for stack overflow */
    if (stackpointer == INCLUDE_STACK_SZ) {
	fprintf(stderr,
	"error: too many nested includes at line %d in file\n\t'%s' !\n",
		linenumber, currparsefile);
	exit(1);
    }

    /* dequote the include filename */
    string_dequote(filename);

    /* save the old file pointer, filename, and linenumber on the stack */
    fp_stack[stackpointer] = *p_fp_old;

    (void) strcpy((pc = (char *) malloc((unsigned) strlen(currparsefile) + 1)), 
					currparsefile);
    filename_stack[stackpointer] = pc;

    linenumber_stack[stackpointer++] = linenumber;

    /* try opening the file */
    if ((fp = fopen(filename, "r")) == NULL) {
	if (errno == ENOENT) {
	    fprintf(stderr,
"error: @@include '%s': file not found at line %d in config file\n\t'%s' !\n",
		    filename, linenumber, currparsefile);
	    exit(1);
	}
	else {
	    char msg[100];
	    sprintf(msg, "%s: fopen()", filename);
	    perror(msg);
	    exit(1);
	}
    }

    /* replace old pointer with new */
    *p_fp_old = fp;

    /* reset line number and filename */
    linenumber = 0;
    strcpy( currparsefile, filename );
}

/*
 * FILE *
 * include_pop()
 *
 *	pop the last file structure off the @@include stack.
 *
 *	returns NULL when we've exhausted the stack.
 */

static FILE *
include_pop()
{
    /* check for stack underflow */
    if (stackpointer-- == 0)
	return NULL;
    (void) fclose(yyin);

    /* pop off the line numbers and the stdio file pointer */
    yyin = fp_stack[stackpointer];

#ifdef FLEX_SCANNER
    yyrestart(yyin);
#endif

    linenumber = linenumber_stack[stackpointer];
    strcpy( currparsefile, filename_stack[stackpointer] );
    free(filename_stack[stackpointer]);

    return yyin;
}

int
check_varname(pc)
    char *pc;
{
    for (; *pc; pc++) {
	if (!(isalnum(*pc) || (*pc == '_'))) {
	    fprintf(stderr,
"warning: illegal character '%c' in @@define at line %d in file\n\t'%s' !\n",
		*pc, linenumber, currparsefile);
	}
    }
    return 0;
}

